> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tabs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.tabs.com/_mcp/server.

# Create contract

POST https://integrators.prod.api.tabsplatform.com/v3/contracts
Content-Type: application/json

Reference: https://docs.tabs.com/api-reference/contracts/createContract

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Tabs External API
  version: 1.0.0
paths:
  /v3/contracts:
    post:
      operationId: integrators-api-contractsv-3-controller-create-contract
      summary: Create contract
      tags:
        - contracts
      parameters:
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created contract
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ContractsV3Dto'
        '400':
          description: Invalid request body
          content:
            application/json:
              schema:
                description: Any type
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateContractV3Dto'
servers:
  - url: https://integrators.prod.api.tabsplatform.com
    description: https://integrators.prod.api.tabsplatform.com
components:
  schemas:
    ExternalIdSourceType:
      type: string
      enum:
        - QUICKBOOKS
        - NETSUITE
        - RILLET
        - SAGE_INTACCT
        - SALESFORCE
        - HUBSPOT
        - AVALARA
        - ANROK
        - STRIPE
      title: ExternalIdSourceType
    ExternalIdDtoMetadata:
      type: object
      properties: {}
      description: Additional metadata for the external identifier
      title: ExternalIdDtoMetadata
    ExternalIdDto:
      type: object
      properties:
        externalId:
          type: string
          description: The external identifier
        sourceType:
          $ref: '#/components/schemas/ExternalIdSourceType'
          description: The source type of the external identifier
        metadata:
          $ref: '#/components/schemas/ExternalIdDtoMetadata'
          description: Additional metadata for the external identifier
      title: ExternalIdDto
    CreateContractV3Dto:
      type: object
      properties:
        name:
          type: string
          description: Name of the Contract
        customerId:
          type: string
          description: customer identifier(UUID)
        externalId:
          $ref: '#/components/schemas/ExternalIdDto'
          description: External identification details, only used for Netsuite Sales Orders
        shouldProcess:
          type: boolean
          default: false
          description: >-
            Deprecated: has no effect. Use shouldProcess query param on the file
            upload endpoint instead.
        closeDate:
          type: string
          description: Close date of the contract
      required:
        - name
        - customerId
      title: CreateContractV3Dto
    ContractsV3DtoSource:
      type: string
      enum:
        - CRM
        - EMAIL
        - UPLOAD
        - API
        - ERP
        - INTERNAL
      description: The source of the contract
      title: ContractsV3DtoSource
    DocumentClassificationType:
      type: string
      enum:
        - ORDER_FORM
        - STATEMENT_OF_WORK
        - AMENDMENT
        - RENEWAL
        - PO
        - MSA
        - INVOICE
        - NONE
      title: DocumentClassificationType
    ContractsV3Dto:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the contract
        fileName:
          type: string
          description: Name of the contract file
        name:
          type: string
          description: Display name of the contract
        status:
          type: string
          description: Current status of the contract
        customerId:
          type: string
          description: Identifier of the customer associated with this contract
        customerName:
          type: string
          description: Name of the customer associated with this contract
        createdAt:
          type: string
          format: date-time
          description: Timestamp when the contract was created
        closeDate:
          type: string
          description: Close date of the contract
        lastUpdatedAt:
          type: string
          description: Timestamp when the contract was last updated
        deletedAt:
          type: string
          format: date-time
          description: >-
            Timestamp when the contract was deleted. Null for live contracts;
            populated on the deleted-contracts endpoint.
        externalIds:
          type: array
          items:
            $ref: '#/components/schemas/ExternalIdDto'
          description: External IDs and external source types of the contract
        source:
          $ref: '#/components/schemas/ContractsV3DtoSource'
          description: The source of the contract
        jobId:
          type: string
          description: The workflow job ID for the contract processing
        documentClassifications:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/DocumentClassificationType'
          description: >-
            Stored document classifications of the contract file. Null when no
            classification data is available; currently only fetching a contract
            by ID returns classification data.
      required:
        - id
        - fileName
        - name
        - status
        - customerId
        - documentClassifications
      title: ContractsV3Dto
  securitySchemes:
    custom-header:
      type: apiKey
      in: header
      name: Authorization

```

## Examples



**Request**

```json
{
  "name": "Contract",
  "customerId": "123e4567-e89b-12d3-a456-426614174000"
}
```

**Response**

```json
{
  "id": "123e4567-e89b-12d3-a456-426614174000",
  "fileName": "Contract.pdf",
  "name": "Contract",
  "status": "ACTIVE",
  "customerId": "123e4567-e89b-12d3-a456-426614174000",
  "documentClassifications": [
    "ORDER_FORM",
    "MSA"
  ],
  "customerName": "John Doe",
  "createdAt": "2024-01-01T00:00:00.000Z",
  "closeDate": "2024-01-01",
  "lastUpdatedAt": "2024-01-01T00:00:00.000Z",
  "deletedAt": "2024-01-01T00:00:00.000Z",
  "externalIds": [
    {
      "externalId": "123e4567-e89b-12d3-a456-426614174000",
      "sourceType": "NETSUITE"
    }
  ],
  "source": "CRM",
  "jobId": "wf-123e4567-e89b-12d3-a456-426614174000"
}
```

**SDK Code**

```python
import requests

url = "https://integrators.prod.api.tabsplatform.com/v3/contracts"

payload = {
    "name": "Contract",
    "customerId": "123e4567-e89b-12d3-a456-426614174000"
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://integrators.prod.api.tabsplatform.com/v3/contracts';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"Contract","customerId":"123e4567-e89b-12d3-a456-426614174000"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://integrators.prod.api.tabsplatform.com/v3/contracts"

	payload := strings.NewReader("{\n  \"name\": \"Contract\",\n  \"customerId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://integrators.prod.api.tabsplatform.com/v3/contracts")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Contract\",\n  \"customerId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://integrators.prod.api.tabsplatform.com/v3/contracts")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Contract\",\n  \"customerId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://integrators.prod.api.tabsplatform.com/v3/contracts', [
  'body' => '{
  "name": "Contract",
  "customerId": "123e4567-e89b-12d3-a456-426614174000"
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://integrators.prod.api.tabsplatform.com/v3/contracts");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Contract\",\n  \"customerId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Contract",
  "customerId": "123e4567-e89b-12d3-a456-426614174000"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://integrators.prod.api.tabsplatform.com/v3/contracts")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```